import { defineComponent, toRefs, watch, computed, unref, openBlock, createElementBlock, normalizeStyle, Fragment, renderList, normalizeClass, createElementVNode, toDisplayString, createCommentVNode, ref, reactive, withDirectives, mergeProps, vModelText, createVNode, nextTick } from "vue";
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
var getInputSelection$1 = { exports: {} };
(function(module, exports) {
  !function(e, t) {
    module.exports = t();
  }(commonjsGlobal, function() {
    return function(e) {
      function t(r) {
        if (n[r])
          return n[r].exports;
        var o = n[r] = { exports: {}, id: r, loaded: false };
        return e[r].call(o.exports, o, o.exports, t), o.loaded = true, o.exports;
      }
      var n = {};
      return t.m = e, t.c = n, t.p = "", t(0);
    }([function(e, t, n) {
      e.exports = n(1);
    }, function(e, t) {
      function n(e2, t2) {
        if (e2)
          if (e2.createTextRange) {
            var n2 = e2.createTextRange();
            n2.move("character", t2), n2.select();
          } else
            e2.selectionStart ? (e2.focus(), e2.setSelectionRange(t2, t2)) : e2.focus();
      }
      Object.defineProperty(t, "__esModule", { value: true }), t["default"] = function(e2) {
        var t2 = 0, n2 = 0;
        if (!e2)
          return { start: t2, end: n2 };
        if (typeof e2.selectionStart == "number" && typeof e2.selectionEnd == "number")
          return { start: e2.selectionStart, end: e2.selectionEnd };
        if (!document)
          return { start: t2, end: n2 };
        var r = document.selection.createRange();
        if (!r && r.parentElement() !== e2)
          return { start: t2, end: n2 };
        var o = e2.value.length, a = e2.value.replace(/\r\n/g, "\n"), c = e2.createTextRange();
        c.moveToBookmark(r.getBookmark());
        var i = e2.createTextRange();
        return i.collapse(false), c.compareEndPoints("StartToEnd", i) > -1 ? t2 = n2 = o : (t2 = -c.moveStart("character", -o), t2 += a.slice(0, t2).split("\n").length - 1, c.compareEndPoints("EndToEnd", i) > -1 ? n2 = o : (n2 = -c.moveEnd("character", -o), n2 += a.slice(0, n2).split("\n").length - 1)), { start: t2, end: n2 };
      }, t.setCaretPosition = n;
    }]);
  });
})(getInputSelection$1);
var getInputSelection = /* @__PURE__ */ getDefaultExportFromCjs(getInputSelection$1.exports);
var textareaCaret = { exports: {} };
(function(module) {
  (function() {
    var properties = [
      "direction",
      "boxSizing",
      "width",
      "height",
      "overflowX",
      "overflowY",
      "borderTopWidth",
      "borderRightWidth",
      "borderBottomWidth",
      "borderLeftWidth",
      "borderStyle",
      "paddingTop",
      "paddingRight",
      "paddingBottom",
      "paddingLeft",
      "fontStyle",
      "fontVariant",
      "fontWeight",
      "fontStretch",
      "fontSize",
      "fontSizeAdjust",
      "lineHeight",
      "fontFamily",
      "textAlign",
      "textTransform",
      "textIndent",
      "textDecoration",
      "letterSpacing",
      "wordSpacing",
      "tabSize",
      "MozTabSize"
    ];
    var isBrowser = typeof window !== "undefined";
    var isFirefox = isBrowser && window.mozInnerScreenX != null;
    function getCaretCoordinates2(element, position, options) {
      if (!isBrowser) {
        throw new Error("textarea-caret-position#getCaretCoordinates should only be called in a browser");
      }
      var debug = options && options.debug || false;
      if (debug) {
        var el = document.querySelector("#input-textarea-caret-position-mirror-div");
        if (el)
          el.parentNode.removeChild(el);
      }
      var div = document.createElement("div");
      div.id = "input-textarea-caret-position-mirror-div";
      document.body.appendChild(div);
      var style = div.style;
      var computed2 = window.getComputedStyle ? window.getComputedStyle(element) : element.currentStyle;
      var isInput = element.nodeName === "INPUT";
      style.whiteSpace = "pre-wrap";
      if (!isInput)
        style.wordWrap = "break-word";
      style.position = "absolute";
      if (!debug)
        style.visibility = "hidden";
      properties.forEach(function(prop) {
        if (isInput && prop === "lineHeight") {
          style.lineHeight = computed2.height;
        } else {
          style[prop] = computed2[prop];
        }
      });
      if (isFirefox) {
        if (element.scrollHeight > parseInt(computed2.height))
          style.overflowY = "scroll";
      } else {
        style.overflow = "hidden";
      }
      div.textContent = element.value.substring(0, position);
      if (isInput)
        div.textContent = div.textContent.replace(/\s/g, "\xA0");
      var span = document.createElement("span");
      span.textContent = element.value.substring(position) || ".";
      div.appendChild(span);
      var coordinates = {
        top: span.offsetTop + parseInt(computed2["borderTopWidth"]),
        left: span.offsetLeft + parseInt(computed2["borderLeftWidth"]),
        height: parseInt(computed2["lineHeight"])
      };
      if (debug) {
        span.style.backgroundColor = "#aaa";
      } else {
        document.body.removeChild(div);
      }
      return coordinates;
    }
    {
      module.exports = getCaretCoordinates2;
    }
  })();
})(textareaCaret);
var getCaretCoordinates = textareaCaret.exports;
var OptionsList_vue_vue_type_style_index_0_lang = "";
const _hoisted_1 = ["onClick", "onMouseenter"];
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  props: {
    helperVisible: {
      type: Boolean,
      default: false
    },
    left: {
      type: Number,
      default: 0
    },
    top: {
      type: Number,
      default: 0
    },
    matchStart: {
      type: Number,
      default: 0
    },
    matchLength: {
      type: Number,
      default: 0
    },
    maxOptions: {
      type: Number,
      default: 6
    },
    options: {
      type: Array,
      default: () => []
    },
    selection: {
      type: Number,
      default: 0
    },
    offsetX: {
      type: Number,
      default: 0
    },
    offsetY: {
      type: Number,
      default: 0
    },
    modelValue: {
      type: String,
      default: null
    }
  },
  emits: ["handle-selection", "set-selection"],
  setup(__props, { emit }) {
    const props = __props;
    const { maxOptions, selection, options, matchStart, matchLength, modelValue } = toRefs(props);
    watch(selection, (newSelectionValue) => {
      if (newSelectionValue >= options.value.length) {
        emit("set-selection", 0);
      }
    });
    const optionsNumber = maxOptions.value === 0 ? options.value.length : maxOptions.value;
    const highlightStart = (val) => {
      if (!modelValue.value)
        return 0;
      return val.toLowerCase().indexOf(modelValue.value.substr(matchStart.value, matchLength.value));
    };
    const computedItems = computed(() => {
      if (Array.isArray(options.value)) {
        return options.value.slice(0, optionsNumber);
      }
      return [];
    });
    return (_ctx, _cache) => {
      return __props.helperVisible && unref(options).length > 0 ? (openBlock(), createElementBlock("ul", {
        key: 0,
        class: "vue-autocomplete-input",
        style: normalizeStyle(`left: ${__props.left + __props.offsetX}; top: ${__props.top + __props.offsetY}px`)
      }, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(computedItems), (item, index2) => {
          return openBlock(), createElementBlock("li", {
            key: index2,
            class: normalizeClass({ active: index2 == unref(selection) }),
            onClick: ($event) => _ctx.$emit("handle-selection", index2),
            onMouseenter: ($event) => _ctx.$emit("set-selection", index2)
          }, [
            createElementVNode("span", null, toDisplayString(item.slice(0, highlightStart(item))), 1),
            createElementVNode("strong", null, toDisplayString(item.substr(highlightStart(item), unref(matchLength))), 1),
            createElementVNode("span", null, toDisplayString(item.slice(highlightStart(item) + unref(matchLength))), 1)
          ], 42, _hoisted_1);
        }), 128))
      ], 4)) : createCommentVNode("", true);
    };
  }
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  props: {
    component: { default: "textarea" },
    defaultValue: { default: "" },
    disabled: { type: Boolean, default: false },
    maxOptions: { default: 6 },
    onBlur: { type: Function, default: () => {
    } },
    onChange: { type: Function, default: () => {
    } },
    onKeyDown: { type: Function, default: () => {
    } },
    onSelect: { type: Function, default: () => {
    } },
    onRequestOptions: { type: Function, default: (newInputValue) => {
      return newInputValue;
    } },
    changeOnSelect: { type: Function, default: (trigger, slug) => {
      return trigger + slug;
    } },
    options: { default: () => ["apple", "ball"] },
    trigger: { default: "@" },
    regex: { default: "^[A-Za-z0-9\\-_]+$" },
    matchAny: { type: Boolean, default: false },
    minChars: { default: 0 },
    requestOnlyIfNoOptions: { type: Boolean, default: true },
    spaceRemovers: { default: () => [",", ".", "!", "?"] },
    spacer: { default: " " },
    offsetX: { default: 0 },
    offsetY: { default: 20 },
    modelValue: { default: null },
    passThroughEnter: { type: Boolean, default: false }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    const KEY_UP = 38;
    const KEY_DOWN = 40;
    const KEY_RETURN = 13;
    const KEY_ENTER = 14;
    const KEY_ESCAPE = 27;
    const KEY_TAB = 9;
    const OPTION_LIST_Y_OFFSET = 10;
    const OPTION_LIST_MIN_WIDTH = 100;
    const inputRef = ref(null);
    const inputValue = ref("");
    const enableSpaceRemovers = ref(false);
    const enableSpaceRemoversPrevLength = ref(0);
    const state = reactive({
      helperVisible: false,
      left: 0,
      trigger: "",
      matchLength: 0,
      matchStart: 0,
      options: [],
      selection: 0,
      top: 0,
      caretEnd: 0
    });
    watch(inputValue, (newInputValue, oldInputValue) => {
      const { onChange, options } = props;
      const caretEnd = getInputSelection(inputRef.value).end;
      if (!newInputValue.length) {
        state.helperVisible = false;
      }
      state.caretEnd = caretEnd;
      if (!newInputValue.length || !caretEnd) {
        return onChange(newInputValue);
      }
      removeSpacer(newInputValue, oldInputValue, caretEnd);
      updateHelper(newInputValue, caretEnd, options);
      if (!inputValue.value) {
        inputValue.value = newInputValue;
      }
      emit("update:modelValue", newInputValue);
      return onChange(newInputValue);
    });
    const resetHelper = async () => {
      await nextTick();
      state.helperVisible = false;
      state.selection = 0;
    };
    const updateHelper = (newInputValue, caretEnd, options) => {
      var _a, _b, _c, _d;
      const slug = getMatch(newInputValue, caretEnd, options);
      if (slug == null) {
        resetHelper();
        return;
      }
      const caretPos = getCaretCoordinates(inputRef.value, caretEnd);
      const rect = (_a = inputRef.value) == null ? void 0 : _a.getBoundingClientRect();
      const top = caretPos.top + ((_b = inputRef.value) == null ? void 0 : _b.offsetTop);
      if (!rect)
        return;
      if (!inputRef.value)
        return;
      const left = Math.min(caretPos.left + ((_c = inputRef.value) == null ? void 0 : _c.offsetLeft) - OPTION_LIST_Y_OFFSET, ((_d = inputRef.value) == null ? void 0 : _d.offsetLeft) + rect.width - OPTION_LIST_MIN_WIDTH);
      const { minChars, onRequestOptions, requestOnlyIfNoOptions } = toRefs(props);
      if (Array.isArray(slug.options)) {
        let shouldUpdateState = slug.matchLength >= minChars.value && (slug.options.length > 1 || slug.options.length === 1 && slug.options[0].length !== slug.matchLength);
        if (shouldUpdateState) {
          state.helperVisible = true;
          state.top = top;
          state.left = left;
          Object.assign(state, slug);
        } else {
          if (!requestOnlyIfNoOptions.value || !slug.options.length) {
            onRequestOptions.value(newInputValue.substr(slug.matchStart, slug.matchLength));
          }
          resetHelper();
        }
      }
    };
    const getMatch = (newInputValue, caretEnd, providedOptions) => {
      const { trigger, matchAny, regex } = props;
      const re = new RegExp(regex);
      let triggers = Array.isArray(trigger) ? trigger : new Array(trigger);
      triggers.sort();
      let providedOptionsObject = {};
      if (Array.isArray(providedOptions)) {
        triggers.forEach((triggerStr) => {
          providedOptionsObject[triggerStr] = providedOptions;
        });
      } else {
        providedOptionsObject = providedOptions;
      }
      const triggersMatch = arrayTriggerMatch(triggers, re);
      let slugData = null;
      for (let triggersIndex = 0; triggersIndex < triggersMatch.length; triggersIndex++) {
        const { triggerStr, triggerMatch, triggerLength } = triggersMatch[triggersIndex];
        for (let i = caretEnd - 1; i >= 0; --i) {
          const substr = newInputValue.substring(i, caretEnd);
          const match = substr.match(re);
          let matchStart = -1;
          if (triggerLength > 0) {
            const triggerIdx = triggerMatch ? i : i - triggerLength + 1;
            if (triggerIdx < 0) {
              break;
            }
            if (isTrigger(triggerStr, newInputValue, triggerIdx)) {
              matchStart = triggerIdx + triggerLength;
            }
            if (!match && matchStart < 0) {
              break;
            }
          } else {
            if (match && i > 0) {
              continue;
            }
            matchStart = i === 0 && match ? 0 : i + 1;
            if (caretEnd - matchStart === 0) {
              break;
            }
          }
          if (matchStart >= 0) {
            const triggerOptions = providedOptionsObject[triggerStr];
            if (triggerOptions == null) {
              continue;
            }
            const matchedSlug = newInputValue.substring(matchStart, caretEnd);
            const options = triggerOptions.filter((slug) => {
              const idx = slug.toLowerCase().indexOf(matchedSlug.toLowerCase());
              return idx !== -1 && (matchAny || idx === 0);
            });
            const currTrigger = triggerStr;
            const matchLength = matchedSlug.length;
            slugData = {
              trigger: currTrigger,
              matchStart,
              matchLength,
              options
            };
          }
        }
      }
      return slugData;
    };
    const arrayTriggerMatch = (triggers, re) => {
      const triggersMatch = triggers.map((trigger) => ({
        triggerStr: trigger,
        triggerMatch: trigger.match(re),
        triggerLength: trigger.length
      }));
      return triggersMatch;
    };
    const isTrigger = (trigger, newInputValue, i) => {
      if (!trigger || !trigger.length) {
        return true;
      }
      if (newInputValue.substr(i, trigger.length) === trigger) {
        return true;
      }
      return false;
    };
    const removeSpacer = (newInputValue, oldInputValue, caretEnd) => {
      const { onChange, options, spaceRemovers, spacer } = props;
      if (!(enableSpaceRemovers.value && spaceRemovers.length && newInputValue.length > 2 && spacer.length))
        return;
      for (let i = 0; i < Math.max(oldInputValue.length, newInputValue.length); ++i) {
        if (oldInputValue[i] !== newInputValue[i]) {
          if (i >= 2 && newInputValue[i - 1] === spacer && spaceRemovers.indexOf(newInputValue[i - 2]) === -1 && spaceRemovers.indexOf(newInputValue[i]) !== -1 && getMatch(newInputValue.substring(0, i - 2), caretEnd - 3, options)) {
            const newValue = `${newInputValue.slice(0, i - 1)}${newInputValue.slice(i, i + 1)}${newInputValue.slice(i - 1, i)}${newInputValue.slice(i + 1)}`;
            inputValue.value = newValue;
            updateCaretPosition(i + 1);
            enableSpaceRemovers.value = false;
            return onChange(newValue);
          }
          break;
        }
      }
      if (newInputValue.length > enableSpaceRemoversPrevLength.value) {
        enableSpaceRemovers.value = false;
      }
    };
    const handleKeyDown = (event) => {
      const { helperVisible, options, selection } = state;
      const { onKeyDown, passThroughEnter } = props;
      if (helperVisible == false) {
        onKeyDown(event);
        return;
      }
      switch (event.keyCode) {
        case KEY_ESCAPE:
          event.preventDefault();
          resetHelper();
          break;
        case KEY_UP:
          event.preventDefault();
          if (Array.isArray(options)) {
            state.selection = (options.length + selection - 1) % options.length;
          }
          break;
        case KEY_DOWN:
          event.preventDefault();
          if (Array.isArray(state.options)) {
            state.selection = (selection + 1) % state.options.length;
          }
          break;
        case KEY_ENTER:
        case KEY_RETURN:
          if (!passThroughEnter) {
            event.preventDefault();
          }
          handleSelection(selection);
          break;
        case KEY_TAB:
          handleSelection(selection);
          break;
        default:
          onKeyDown(event);
          break;
      }
    };
    const handleSelection = (idx) => {
      const { spacer, onSelect, changeOnSelect } = props;
      const { matchStart, matchLength, options, trigger } = state;
      if (!Array.isArray(options))
        return;
      if (!(typeof trigger == "string"))
        return;
      const slug = options[idx];
      const part1 = trigger.length === 0 ? "" : inputValue.value.substring(0, matchStart - trigger.length);
      const part2 = inputValue.value.substring(matchStart + matchLength);
      const changedStr = changeOnSelect(trigger, slug);
      inputValue.value = `${part1}${changedStr}${spacer}${part2}`;
      onSelect(inputValue.value);
      resetHelper();
      updateCaretPosition(part1.length + changedStr.length + 1);
      enableSpaceRemovers.value = true;
      enableSpaceRemoversPrevLength.value = inputValue.value.length;
    };
    const updateCaretPosition = (caretEnd) => {
      state.caretEnd = caretEnd;
      getInputSelection$1.exports.setCaretPosition(inputRef.value, caretEnd);
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", null, [
        withDirectives(createElementVNode("textarea", mergeProps({
          name: "my-textarea",
          id: "myTextarea",
          rows: "2",
          ref_key: "inputRef",
          ref: inputRef,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => inputValue.value = $event),
          onKeydown: handleKeyDown
        }, _ctx.$attrs), null, 16), [
          [vModelText, inputValue.value]
        ]),
        createVNode(_sfc_main$1, {
          "helper-visible": unref(state).helperVisible,
          left: unref(state).left,
          top: unref(state).top,
          "match-start": unref(state).matchStart,
          "match-length": unref(state).matchLength,
          "max-options": __props.maxOptions,
          options: unref(state).options,
          selection: unref(state).selection,
          "offset-x": __props.offsetX,
          "offset-y": __props.offsetY,
          modelValue: inputValue.value,
          "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => inputValue.value = $event),
          onHandleSelection: handleSelection,
          onSetSelection: _cache[2] || (_cache[2] = (hoveredIndex) => unref(state).selection = hoveredIndex)
        }, null, 8, ["helper-visible", "left", "top", "match-start", "match-length", "max-options", "options", "selection", "offset-x", "offset-y", "modelValue"])
      ]);
    };
  }
});
var index = {
  install: (app) => {
    app.component("AutoCompleteTextField", _sfc_main);
  }
};
export { _sfc_main as AutoCompleteTextField, index as default };
